from tools import execcmd
from pcihole import pcigetbyte_str,pcigetword_int,bdclass,tongaID



def pcigetdword_int(cfg_space,bdf,offset):
    return pcigetword_int(cfg_space,bdf,offset+2) << 16 | pcigetword_int(cfg_space,bdf,offset);


if __name__=='__main__':
    #all bridges, tongas, and pci configuration space
    bridge_bdf=execcmd("lspci -n | grep \"%s\" | cut -d \" \" -f 1" %(bdclass))
    tonga_bdf=execcmd("lspci -n | grep \"%s\" | cut -d \" \" -f 1" %(tongaID))
    pci_cfg_space=execcmd("lspci -e")

    bridge2bus_bdf={}

    ifinrange = True

    #mark all bridges with its subbus
    for line in bridge_bdf.splitlines():
        #get its subbus
        subbus = pcigetbyte_str(pci_cfg_space,line,0x19)
        #add it to dict bridge2bus_bdf[subbus]=bdf of the bridge
        bridge2bus_bdf[subbus] = line

    for line in tonga_bdf.splitlines():
        #get its bus
        bus = line.split(":")[1]
        #get the prefetchable memory upper 32 bit addresses
        membase=pcigetdword_int(pci_cfg_space,bridge2bus_bdf[bus],0x28)
        memlimit=pcigetdword_int(pci_cfg_space,bridge2bus_bdf[bus],0x2C)
        #If it is in 40-bit address range
        if (memlimit - membase) & 0xffffff00 == 0:
            pass
        else:
            ifinrange=False

    if ifinrange == True:
        print("y")
    else:
        print("n")
