from __future__ import division, print_function, unicode_literals
import subprocess
import string
import os
import re
import sys

#define input for python 2 & 3 compatibility
if sys.version_info[:2] <= (2, 7):
        input = raw_input
'''
import paramiko
import threading
'''

def execcmd(cmd,params=None):
    return str(subprocess.check_output(cmd, shell=True).decode('utf-8')).strip()
    
def BDF(bdf):
    #offset for case of bdf XXXX:XX:XX.X
    offset = 0 if len(bdf.split(':')) == 2 else 1
    bus=bdf.split(':')[0 + offset]
    device=bdf.split(':')[1 + offset].split(".")[0]
    function=bdf.split(':')[1 + offset].split(".")[1]
    return (int(bus,16),int(device),int(function))

def ReExpMatch(rexp,target):
    return re.findall(rexp,target)
    
if __name__=='__main__':
    scan_rawdata = execcmd("vim-cmd vmsvc/getallvms | awk \"NR>1\"",None)
    for line in scan_rawdata.split('\n'):
        if len(line) == 0:
            continue
        res = ReExpMatch('(\d+?)\s{3,}(\S.*?)\s{3,}\[(\S.*)\]\s(\S.*?)\s{3,}',line)
        print(res)

    